Get All Owned IP Ranges

Cortex Xpanse REST API

post /public_api/v1/assets/get_external_ip_address_ranges/

Get a list of all your owned IP address ranges filtered by business units and organization handles.
The maximum result limit is 1000 ranges.
Note: You can send a request to retrieve either all or filtered results.
Required license: Cortex Xpanse Expander

Request headers
authorization String required

api-key

Example: {{api_key}}
x-xdr-auth-id String required

api-key-id

Example: {{api_key_id}}
CLIENT REQUEST
curl -X 'POST'
-H 'Accept: application/json'
-H 'Content-Type: application/json'
-H 'authorization: {{api_key}}' -H 'x-xdr-auth-id: {{api_key_id}}'
'https://api-}/public_api/v1/assets/get_external_ip_address_ranges/'
-d '{ "request_data" : { "search_from" : 0, "next_page_token" : "next_page_token", "filters" : [ { "field" : "organization_handles", "value" : "ExternalIpAddressRangesFilter_value", "operator" : "in" }, { "field" : "organization_handles", "value" : "ExternalIpAddressRangesFilter_value", "operator" : "in" } ], "sort" : { "field" : "first_ip", "keyword" : "desc" }, "search_to" : 0, "use_page_token" : true } }'
import http.client conn = http.client.HTTPSConnection("api-") payload = "{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}" headers = { 'authorization': "{{api_key}}", 'x-xdr-auth-id': "{{api_key_id}}", 'content-type': "application/json" } conn.request("POST", "%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/", payload, headers) res = conn.getresponse() data = res.read() print(data.decode("utf-8"))
require 'uri' require 'net/http' require 'openssl' url = URI("https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true http.verify_mode = OpenSSL::SSL::VERIFY_NONE request = Net::HTTP::Post.new(url) request["authorization"] = '{{api_key}}' request["x-xdr-auth-id"] = '{{api_key_id}}' request["content-type"] = 'application/json' request.body = "{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}" response = http.request(request) puts response.read_body
const data = JSON.stringify({ "request_data": { "filters": [ { "field": "organization_handles", "operator": "in", "value": "string" } ], "search_from": 0, "search_to": 500, "sort": { "field": "last_ip", "keyword": "ASC" }, "use_page_token": true, "next_page_token": "string" } }); const xhr = new XMLHttpRequest(); xhr.withCredentials = true; xhr.addEventListener("readystatechange", function () { if (this.readyState === this.DONE) { console.log(this.responseText); } }); xhr.open("POST", "https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/"); xhr.setRequestHeader("authorization", "{{api_key}}"); xhr.setRequestHeader("x-xdr-auth-id", "{{api_key_id}}"); xhr.setRequestHeader("content-type", "application/json"); xhr.send(data);
HttpResponse<String> response = Unirest.post("https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/") .header("authorization", "{{api_key}}") .header("x-xdr-auth-id", "{{api_key_id}}") .header("content-type", "application/json") .body("{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}") .asString();
import Foundation let headers = [ "authorization": "{{api_key}}", "x-xdr-auth-id": "{{api_key_id}}", "content-type": "application/json" ] let parameters = ["request_data": [ "filters": [ [ "field": "organization_handles", "operator": "in", "value": "string" ] ], "search_from": 0, "search_to": 500, "sort": [ "field": "last_ip", "keyword": "ASC" ], "use_page_token": true, "next_page_token": "string" ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume()
<?php $curl = curl_init(); curl_setopt_array($curl, [ CURLOPT_URL => "https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/", CURLOPT_RETURNTRANSFER => true, CURLOPT_ENCODING => "", CURLOPT_MAXREDIRS => 10, CURLOPT_TIMEOUT => 30, CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_POSTFIELDS => "{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}", CURLOPT_HTTPHEADER => [ "authorization: {{api_key}}", "content-type: application/json", "x-xdr-auth-id: {{api_key_id}}" ], ]); $response = curl_exec($curl); $err = curl_error($curl); curl_close($curl); if ($err) { echo "cURL Error #:" . $err; } else { echo $response; }
CURL *hnd = curl_easy_init(); curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST"); curl_easy_setopt(hnd, CURLOPT_URL, "https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/"); struct curl_slist *headers = NULL; headers = curl_slist_append(headers, "authorization: {{api_key}}"); headers = curl_slist_append(headers, "x-xdr-auth-id: {{api_key_id}}"); headers = curl_slist_append(headers, "content-type: application/json"); curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers); curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}"); CURLcode ret = curl_easy_perform(hnd);
var client = new RestClient("https://api-/%7B%7Bfqdn%7D%7D/public_api/v1/assets/get_external_ip_address_ranges/"); var request = new RestRequest(Method.POST); request.AddHeader("authorization", "{{api_key}}"); request.AddHeader("x-xdr-auth-id", "{{api_key_id}}"); request.AddHeader("content-type", "application/json"); request.AddParameter("application/json", "{\"request_data\":{\"filters\":[{\"field\":\"organization_handles\",\"operator\":\"in\",\"value\":\"string\"}],\"search_from\":0,\"search_to\":500,\"sort\":{\"field\":\"last_ip\",\"keyword\":\"ASC\"},\"use_page_token\":true,\"next_page_token\":\"string\"}}", ParameterType.RequestBody); IRestResponse response = client.Execute(request);
Body parameters
required
application/json
request_dataobject

A dictionary containing the API request fields. An empty dictionary returns all results.

filtersarray

Array of filter fields.

[
fieldstring (Enum)

Identifies the external IP ranges field the filter is matching. Filters are based on the following case-sensitive keywords:

  • business_units_list
  • organization_handles
  • Ipaddress_version
  • has_bu_overrides
  • tags
Allowed values:"organization_handles""tags""business_units_list""ipaddress_version""has_bu_overrides"
operatorstring (Enum)

Identifies the comparison operator you want to use for this filter. Valid keywords and values are:

  • contains / not_contains
    • organization_handles
  • in
    • business_units_list
    • tags
  • eq / neq
    • ipaddress_version
    • has_bu_overrides
Allowed values:"in""contains""neq""eq""not_contains"
valueobject

Values depend on the filter field used.

  • organization_handles — string
  • business_units_list — string or list of strings with syntax “Acme & Co, Inc.” or “BU:Acme & Co, Inc.”
  • tags — list of strings in format “{family alias}:{tag name}”
  • ipaddress_version — integer
  • has_bu_overrides - boolean (true/false)
string

Values depend on the filter field used.

  • organization_handles — string
  • business_units_list — string or list of strings with syntax “Acme & Co, Inc.” or “BU:Acme & Co, Inc.”
  • tags — list of strings in format “{family alias}:{tag name}”
  • ipaddress_version — integer
  • has_bu_overrides - boolean (true/false)
boolean

Values depend on the filter field used.

  • organization_handles — string
  • business_units_list — string or list of strings with syntax “Acme & Co, Inc.” or “BU:Acme & Co, Inc.”
  • tags — list of strings in format “{family alias}:{tag name}”
  • ipaddress_version — integer
  • has_bu_overrides - boolean (true/false)
integer

Values depend on the filter field used.

  • organization_handles — string
  • business_units_list — string or list of strings with syntax “Acme & Co, Inc.” or “BU:Acme & Co, Inc.”
  • tags — list of strings in format “{family alias}:{tag name}”
  • ipaddress_version — integer
  • has_bu_overrides - boolean (true/false)
Array
Free-Form object
]
search_frominteger

Represents the start offset index of results.

search_tointeger

An integer representing the start offset index of results. Use this field to specify the number of results on a page when using page token pagination.
Default value - 500
Max value - 1000

Default:500
sortobject

Identifies the sort order for the result set.

fieldstring (Enum)

Values are:

  • Id
  • first_ip
  • last_ip
    Case sensitive.
    Default is first_ip.
Default:"first_ip"
Allowed values:"last_ip""last_ipv6""first_ipv6""first_ip""ipaddress_version""range_id_list"
keywordstring (Enum)

Value are:

  • ASC (ascending order)
  • DESC (descending order). Case sensitive. Default is DESC.
Default:"desc"
Allowed values:"ASC""asc""DESC""desc"
Free-Form object
use_page_tokenboolean

Use "use_page_token":true in the initial request to paginate the response data.

next_page_tokenstring

If "use_page_token":true was included in the initial request, the response for that request will include a page token. Use "next_page_token":"string" to pass that page token into the next request to paginate the next set of data.

Free-Form object
REQUEST
{ "request_data": { "filters": [ { "field": "organization_handles", "operator": "in", "value": "example" } ], "search_from": 0, "search_to": 0, "sort": { "field": "last_ip", "keyword": "ASC" }, "use_page_token": false, "next_page_token": "example" } }
Responses

OK

Body
application/json
replyobject
total_countinteger
result_countinteger
external_ip_address_rangesarray
[
range_idstring
first_ipstring
last_ipstring
ips_countinteger
active_responsive_ips_countinteger
date_addedinteger
organization_handlesarray[string]
ipaddress_versioninteger
tagsarray[string]
first_ipv6string
last_ipv6string
annotationstring
has_bu_overridesboolean
Free-Form object
]
next_page_tokenstring

This attribute is only returned if use_page_token is provided in the request with value true

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "total_count": 0, "result_count": 0, "external_ip_address_ranges": [ { "range_id": "example", "first_ip": "example", "last_ip": "example", "ips_count": 0, "active_responsive_ips_count": 0, "date_added": 0, "organization_handles": [ "example" ], "ipaddress_version": 0, "tags": [ "example" ], "first_ipv6": "example", "last_ipv6": "example", "annotation": "example", "has_bu_overrides": false } ], "next_page_token": "example" } }

Bad Request. Got an invalid JSON.

Body
application/json
replyobject

The query results upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

err_extrastring

Additional information describing the error.

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "err_code": "example", "err_msg": "example", "err_extra": "example" } }

Unauthorized access. An issue occurred during authentication. This can indicate an incorrect key, id, or other invalid authentication parameters.

Body
application/json
replyobject

The query results upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

err_extrastring

Additional information describing the error.

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "err_code": "example", "err_msg": "example", "err_extra": "example" } }

Unauthorized access. User does not have the required license type to run this API.

Body
application/json
replyobject

The query results upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

err_extrastring

Additional information describing the error.

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "err_code": "example", "err_msg": "example", "err_extra": "example" } }

Forbidden access. The provided API Key does not have the required RBAC permissions to run this API.

Body
application/json
replyobject

The query results upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

err_extrastring

Additional information describing the error.

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "err_code": "example", "err_msg": "example", "err_extra": "example" } }

Unprocessable Entity

Body
application/json
codeinteger

Error code

statusstring

Error name

messagestring

Error message

errorsobject

Errors

RESPONSE
{ "code": 0, "status": "example", "message": "example", "errors": {} }

Internal server error. A unified status for API communication type errors.

Body
application/json
replyobject

The query results upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

err_extrastring

Additional information describing the error.

Free-Form object
Free-Form object
RESPONSE
{ "reply": { "err_code": "example", "err_msg": "example", "err_extra": "example" } }